<?php

namespace FiloBlu\ExtAmastyGeoipRedirect\Plugin\App\Config;

/**
 * Class ScopeConfigInterface
 * @package FiloBlu\ExtAmastyGeoipRedirect\Plugin\App\Config
 */
class ScopeConfigInterface
{

    /**
     * @var \Magento\Framework\Stdlib\CookieManagerInterface
     */
    protected $cookieManager;

    /**
     * ScopeConfigInterface constructor.
     * @param \Magento\Framework\Stdlib\CookieManagerInterface $cookieManager
     */
    public function __construct(\Magento\Framework\Stdlib\CookieManagerInterface $cookieManager)
    {
        $this->cookieManager = $cookieManager;
    }

    /**
     * @param \Magento\Framework\App\Config\ScopeConfigInterface $subject
     * @param $result
     * @param $path
     * @param string $scopeType
     * @param string $scopeCode
     * @return string|null
     */
    public function afterGetValue(\Magento\Framework\App\Config\ScopeConfigInterface $subject, $result, $path,
                                  $scopeType = \Magento\Framework\App\Config\ScopeConfigInterface::SCOPE_TYPE_DEFAULT,
                                  $scopeCode = null
    )
    {
        switch ($path) {
            case \Magento\Tax\Model\Config::CONFIG_XML_PATH_DEFAULT_COUNTRY:
            case \Magento\Directory\Helper\Data::XML_PATH_DEFAULT_COUNTRY:
                return $this->cookieManager->getCookie(\FiloBlu\ExtAmastyGeoipRedirect\Cookie\Country::COOKIE_NAME, $result);
            default:
                return $result;
        }
    }
}